<?php
    /*
    Plugin Name: Импорт rss каналов
    Plugin URI: http://www.shopos.ru/ 
    Version: 1.0
    Author: Матецкий Евгений
    Author URI: http://www.shopos.ru/
    */

    //импорт товаров
    add_action('main_page_admin', 'news_import_page');

    //главная страница плагина
    add_action('main_page_admin', 'news_import_main_page');

    //скачивание файла
    add_action('page_admin', 'news_dawnload_file_page');

    //добавление rss канала
    add_action('page_admin', 'news_add_rss');
    //удаление rss канала
    add_action('page_admin', 'news_delete_rss');

    //страница для крона. index.php?page=news_cron_import_rss
    add_action('page', 'news_cron_import_rss');
    add_action('page_admin', 'news_cron_import_rss');

    //так же для крона
    add_action('cron', 'news_cron_import_rss');

    //страница с настройками плагина
    function news_import_main_page()
    {
        include( plugdir() . 'form.html' );
    }

    //добавление rss канала
    function news_add_rss()
    {
        if ( isset( $_POST['rss_url'] ) && !empty( $_POST['rss_url'] ) )
        {
            os_db_query("INSERT INTO `".DB_PREFIX."rss_channel` (`rss_channel`) VALUES ('".$_POST['rss_url']."');");
        }

        os_redirect('plugins_page.php?main_page=news_import_main_page');
    }

    function news_cron_import_rss()
    {
        global $_count_news;

        $_count_news = 0;
        $_count_feeds = 1;

        $_rss_channel = os_db_query("select rss_channel, rss_id from ".DB_PREFIX."rss_channel");

        if (os_db_num_rows($_rss_channel,true)) 
        { 
            $_rss_keys = os_db_query("select news_id, rss_key from ".DB_PREFIX."rss_unical");

            while ($__rss= os_db_fetch_array($_rss_keys, true)) 
            {
                $rss_keys[ $__rss['rss_key'] ] = $__rss['news_id'];
            }

            while ($_rss= os_db_fetch_array($_rss_channel,true))  
            {
                // echo $_rss['rss_channel'].'<br>';
                $sxe = simplexml_load_file($_rss['rss_channel']);

                foreach ($sxe->channel->item as $_value)
                {
                    $_key = base64_encode($_value->title);

                    if ( !isset($rss_keys[$_key]) )
                    {
                        add_news_rss($_value, $_rss['rss_channel']);
                    }
                }

                //создаем кэш seo-url
               @ set_news_url_cache();

                echo $_count_feeds.'. Add '.$_count_news." news\n";
                $_count_feeds++;
                // foreach ($sxe)
            } 
        }

    }

    //Добавдение новости в магазин
    function add_news_rss($_value, $_source)
    {
        global $_count_news;

        $_description = strip_tags($_value->description);
        $_description = str_replace('...', '.', $_description);
        $_description = str_replace('..', '.', $_description);
        $_description = str_replace('Подробнее об этом читайте на страницах www.thg.ru.', '.', $_description);

        $_name = $_value->title;
        $_seo_url = 'news-'.strtolower( os_cleanName($_name) ).'.html';
        $_seo_url = str_replace('--', '-', $_seo_url);
        $_seo_url = str_replace('--', '-', $_seo_url);

        $sql_data_array = array('headline'   => os_db_prepare_input($_name),
        'news_page_url'    => os_db_prepare_input($_seo_url),
        'content'    => os_db_prepare_input($_description),
        'date_added' => 'now()',
        'language'   => '1',
        'status'     => '1' );

        os_db_perform(TABLE_LATEST_NEWS, $sql_data_array);

        $news_id = os_db_insert_id();
        $_key = base64_encode($_name); 
        $_count_news++;
        os_db_query("replace INTO `".DB_PREFIX."rss_unical` (`news_id`, `rss_key`, `source`) VALUES ('".$news_id."', '".$_key."', '".$_source."');");
    }

    //удалиние rss канала
    function news_delete_rss()
    {
        if ( isset( $_GET['id'] ) && !empty( $_GET['id'] ) )
        {
            $_id = (int)$_GET['id'];
            os_db_query("delete from `".DB_PREFIX."rss_channel` where rss_id=$_id");
            os_redirect('plugins_page.php?main_page=news_import_main_page');
        }
    }

    function shopos_news_import_page_readonly()
    {
        _e('<center>'.add_button('main_page', 'news_import_main_page', 'Настройки' ).'</center>');
    }

    function import_rss_install()
    {
        global $db;

        add_option('shopos_news_import_page', '', 'readonly');

        $db->query("drop table if exists ".DB_PREFIX."rss_channel;");

        $db->query("CREATE TABLE ".DB_PREFIX."rss_channel (
        rss_id int NOT NULL auto_increment,
        rss_channel varchar(255) NOT NULL,
        PRIMARY KEY (rss_id)
        ) ENGINE=MyISAM DEFAULT CHARSET=utf8 COLLATE utf8_general_ci;");

        $db->query("drop table if exists ".DB_PREFIX."rss_unical");

        //для уникализации добавляемых элементов 
        $db->query("CREATE TABLE IF NOT EXISTS ".DB_PREFIX."rss_unical (
        `rss_id` int(11) NOT NULL auto_increment,
        `news_id` int(11) NOT NULL,
        `rss_key` text NOT NULL,
        `source` varchar(255) NOT NULL,
        PRIMARY KEY  (`rss_id`)
        ) ENGINE=MyISAM  DEFAULT CHARSET=utf8 AUTO_INCREMENT=208 ;");

    }

    function import_rss_remove()
    {
        global $db;
        
        $db->query("drop table if exists ".DB_PREFIX."rss_channel");
        $db->query("drop table if exists ".DB_PREFIX."rss_unical");
    }
?>